Codeforces Round #436 (Div. 2) 864D.Make a Permutation!

3 篇文章 0 订阅
2 篇文章 0 订阅

那天晚上发现有场cf时间比较早就跑去打了一下,只写出ABCDE的我(一次都没被hack,也一次都没去hack)……


地址:Codeforces Round #436 (Div. 2) 864D.Make a Permutation!


题面:

D. Make a Permutation!

time limit per test : 2 seconds
memory limit per test : 256 megabytes
input : standard input
output : standard output


Ivan has an array consisting of n elements. Each of the elements is an integer from 1 to n.

Recently Ivan learned about permutations and their lexicographical order. Now he wants to change (replace) minimum number of elements in his array in such a way that his array becomes a permutation (i.e. each of the integers from 1 to n was encountered in his array exactly once). If there are multiple ways to do it he wants to find the lexicographically minimal permutation among them.

Thus minimizing the number of changes has the first priority, lexicographical minimizing has the second priority.

In order to determine which of the two permutations is lexicographically smaller, we compare their first elements. If they are equal — compare the second, and so on. If we have two permutations x and y, then x is lexicographically smaller if xi < yi, where i is the first index in which the permutations x and y differ.

Determine the array Ivan will obtain after performing all the changes.


Input
The first line contains an single integer n (2 ≤ n ≤ 200 000) — the number of elements in Ivan’s array.

The second line contains a sequence of integers a1, a2, …, an (1 ≤ ai ≤ n) — the description of Ivan’s array.


Output
In the first line print q — the minimum number of elements that need to be changed in Ivan’s array in order to make his array a permutation. In the second line, print the lexicographically minimal permutation which can be obtained from array with q changes.


Examples
input

4
3 2 2 3

output

2
1 2 4 3 

input

6
4 5 6 3 2 1

output

0
4 5 6 3 2 1 

input

10
6 8 4 6 7 1 6 3 4 5

output

3
2 8 4 6 7 1 9 3 10 5 

Note
In the first example Ivan needs to replace number three in position 1 with number one, and number two in position 3 with number four. Then he will get a permutation [1, 2, 4, 3] with only two changed numbers — this permutation is lexicographically minimal among all suitable.

In the second example Ivan does not need to change anything because his array already is a permutation.


题解:

题目大意什么的怕误导一些人,可以去google翻译一下。
首先求最小的操作次数应该是简单的,就是原序列中缺几个数字就是几;
之后最小的字典序方案的做法的话,一看最小之类的,要不dp就是贪心(毕竟 N 200000)。本题是 O(n) 贪心。
先一开始用一个数组存下每个数字出现的次数,毕竟如果一个数字只出现一次的话,就不会在上面进行修改操作,只会在出现超过一次的数进行操作。
因为是字典序最小,显然空缺的数填在越前面越优,但它替换的数应当比它大,否则就会使字典序变大,但有如果有两个 3 缺个5的情况这么判的话, 5 就填不进去了。
可以这么解决,因为每个数只在序列中出现一次,所以当第一次5>3的时候我们就给 3 打个标记,表示3 已经填进序列中了,下次必须要替换了。


代码:

#include<vector>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;
#define ll long long
#define N 200005
inline int read(){
    int x=0,f=1;char ch=getchar();
    while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
    while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();}
    return x*f;
}

int n;
int a[N];
int cnt,ans;
int num[N];
bool vis[N];

int main(){
    n = read();
    for(int i = 1;i <= n;i++){
        a[i] = read();
        num[a[i]]++;
        if(num[a[i]] > 1) ans++;
    }
    cnt = 1;
    while(num[cnt] > 0) 
        cnt++;
    for(int i = 1;i <= n;i++){
        if(num[a[i]] > 1){
            if(cnt < a[i] || vis[a[i]]){
                num[a[i]]--; a[i] = cnt;
                num[cnt]++;
                while(num[cnt] > 0)
                    cnt++;
            }
            else vis[a[i]] = true;
        }
    }
    printf("%d\n",ans);
    for(int i = 1;i < n;i++)
        printf("%d ",a[i]);
    printf("%d\n",a[n]);
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值